// SRShellEx.h : Declaration of the CSRShellEx

#ifndef __SRSHELLEX_H_
#define __SRSHELLEX_H_

#include "resource.h"       // main symbols

#include <comdef.h>
#include <shlobj.h>
#include <shlguid.h>

/////////////////////////////////////////////////////////////////////////////
// CSRShellEx
class ATL_NO_VTABLE CSRShellEx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSRShellEx, &CLSID_SRShellEx>,
	public IDispatchImpl<ISRShellEx, &IID_ISRShellEx, &LIBID_SYMRETSHELLEXLib>,
	public IShellExtInit,
	public IContextMenu
{
public:
	CSRShellEx();
	virtual ~CSRShellEx();

DECLARE_REGISTRY_RESOURCEID(IDR_SRSHELLEX)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSRShellEx)
	COM_INTERFACE_ENTRY(ISRShellEx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()

// ISRShellEx
public:


// Implementation.
protected:
	HBITMAP					m_hbmpBitmap;
	charstring_vector		m_vcsFiles;

// IShellExtInit
public:
	STDMETHOD( Initialize )( LPCITEMIDLIST, LPDATAOBJECT, HKEY );

// IContextMenu
public:
    STDMETHOD( GetCommandString )( UINT, UINT, UINT*, LPSTR, UINT );
    STDMETHOD( InvokeCommand )( LPCMINVOKECOMMANDINFO );
    STDMETHOD( QueryContextMenu )( HMENU, UINT, UINT, UINT, UINT );
};

#endif //__SRSHELLEX_H_
